//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "formMain.h"

#include "rijndael_alg_fst.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  // Clear the second memo
  Memo2->Text = "";

  // Snage the original text to encrypt and its length
  unsigned int iLen = Memo1->Text.Length();
  //char *pEncBuf = new char[iLen+1];
  //memset(pEncBuf,0,iLen+1);
  //memcpy(pEncBuf,Memo1->Text.c_str(),iLen);

  // Encrypt the text using the user specified password
  char *pEncBuf = EncryptBuffer(Edit1->Text.c_str(), Edit1->Text.Length(), Memo1->Text.c_str(), iLen);

  // Since we working with Edit boxes store the binary excrypted data as viewable HEX characters
  // This step is only required when you Don't want unviewable chars or unexpected NULL characters
  // in your encrypted string
  char *pHexText = EncryptedBufferToHexText((const char *)pEncBuf,iLen);

  // Assign the Hex Encoded encrypted string to the second memo
  Memo2->Text = pHexText;

  delete [] pEncBuf;
  pEncBuf = NULL;

  delete [] pHexText;
  pHexText = NULL;

  Memo1->Text = "";
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  // Clear the first memo
  Memo1->Text = "";

  // Get the length of the Hex Encoded encrypted string
  unsigned int iLen = Memo2->Text.Length();

  // Convert to Binary encrypted string
  char *pDecBufBin = HexTextToEncryptedBuffer(Memo2->Text.c_str(),iLen);

  // Decrypt
  char *pDecBuf = DecryptBuffer(Edit1->Text.c_str(), Edit1->Text.Length(), (const char *)pDecBufBin, iLen);

  Memo1->Text = pDecBuf;

  delete [] pDecBufBin;
  pDecBufBin = NULL;

  delete [] pDecBuf;
  pDecBuf = NULL;

  Memo2->Text = "";
}

//---------------------------------------------------------------------------

